#include<iostream>	
using namespace std;

//include the header so the file is aware of the class
#include"date.h"
//NOTE:		the < and > are used for system files
//			the " and " are used for user created files


/*get functions
	simply return the current value of the attribute
	:: scope resolution, function belongs to class
*/

//int getDay();	
int date::getDay() {return day;}
int date::getMonth() {return month;}	
int date::getYear() {return year;}	


/*set functions
	accept an argument use it to change the current value
	of the attribute

	:: scope resolution (as before)
*/

void date::setYear(int i)
{
	//the year can be whatever
	year = i;
}

void date::setMonth(int i)
{
	//validate on 1<month<12
	if(i>0 && i<13)
	{
		month = i;
	}
	else 
	{
		//invalid
		month = 1;
	}
}

void date::setDay(int i) 
{
	//a relatively complicated validation
	
	//below are the maximum days for each month (except february)
	int daysOfMonth[] = {0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
	
	if (i <= daysOfMonth[month])
	{
		//acceptable
		day = i;
	}
	else
	{
		//days are above maximum, only special case is Feb
		if (month==2 && i==29 && isLeap(year))
		{
			//ok
			day = i;
		}
		else
		{
			//invalid
			day = 1; //set to default
		}
	}
}

bool date::isLeap(int arg)
{
	//a year is leap if
	// - if it exactly divisible by 400
	// OR
	// - if it exaclty divisible by 4 but NOT by 100
	int a_case = arg%400==0;
	int b_case = (arg%4==0 && arg%100!=0);
	if (a_case || b_case)
	{
		return true;
	}
	else
	{
		return false;
	}
}













/* the constructor
	1. same name as the class
	2. does not return a value
	3. scope resolved
	4. takes as many argument as are the data attributes*/

//original date(int d=1, int m=1, int y=2021);	
date::date(int d, int m, int y)
{
	//because the day depending on month and year we set it last
	setYear(y);	
	setMonth(m); 
	setDay(d);  //day = d;
	
}











/* the print
	a function to output the 'object' details
 */	

	void date::print()
	{
		cout << day << "/" << month << "/" << year << "\n";
		//cout << day << "/" << month << "/" << year << endl;
	}







