#include"triangle.h"
#include<iostream>
using namespace std;
void triangle::setTop(vertex arg){top=arg; }
void triangle::setRightVertex(vertex arg){ rightVertex=arg;}
void triangle::setLeftVertex(vertex arg){leftVertex=arg; }
void triangle::setBase(edge arg){ base=arg;}
void triangle::setRightEdge(edge arg){ rightEdge=arg;}
void triangle::setLeftEdge(edge arg){leftEdge=arg; }

vertex triangle::getTop(){return top; }
vertex triangle::getLeftVertex(){ return leftVertex;}
vertex triangle::getRightVertex(){ return rightVertex;}
edge triangle::getBase(){ return base; }
edge triangle::getLeftEdge(){ return leftEdge;}
edge triangle::getRightEdge(){ return rightEdge;}

triangle::triangle (string n, vertex lv, vertex rv, vertex tp, edge b, edge l, edge r)
:shape2d(n, 3, 1, 3) 
{
	setBase(b);
	setLeftEdge(l);
	setRightEdge(r);
	
	setLeftVertex(leftEdge.getStart()); // (lv)
	setRightVertex(rightEdge.getEnd()); // (rv)
	setTop(leftEdge.getEnd());			// (tp)
	
	setEdges(3);
	setVertices(3);
} 

//override
void triangle::setEdges(int arg){ 
	edges = arg==3 ? arg : 3;
}
void triangle::setVertices(int arg){
	vertices = arg==3 ? arg : 3;
}


/* THIS CLASS IS CONCRETE */
double triangle::perimeter(){ 
	//calculate and return
	//sum of the lenghs of the edges
	return (base.length() + leftEdge.length() + rightEdge.length());
}
double triangle::area(){
	//calculate and return
	// (base * height)/2
	
	//calulcate the slope of the base (y2-y1)/(x2-x1)
	double baseslope = (double)(rightVertex.getY()-leftVertex.getY())/ (double)(rightVertex.getX()-leftVertex.getX());
	//claculate the slope of the height inverse reciprocal of the base slope
	double heightslope = -1./baseslope;
	if (baseslope==0)
	{
		heightslope = -1;
	}
	//cout << "height slope: " << heightslope << endl;
	
	//knowing the slope and a general line equation: y = slope*x + intercept
	//solve for intercept = y-slope*x
	double intercept = top.getY()-(heightslope*top.getX());
	
	//knowning the intercept, 
	//calculate where the height hits the base
	int heighty = (int)intercept;
	int heightx = top.getX();
	
	//create the edge for the height;
	edge height = edge("height", top, vertex("height_at_base", heightx, heighty, 0));
	
	//now we know the base and the height
	double result = (base.length()*height.length())/2.0;
	
	return result; 
}

double triangle::volume(){ return 0; }

string triangle::draw(){ 
	string result = " /|\n";
	result = result + "/_|\n";
	return result;
}
